/****************************************************************************************/
/* Racer3.c - functions and data for racer #2                                           */
/*--------------------------------------------------------------------------------------*/

#define  P3_START_X        212
#define  P3_START_Y        200

int  p3x[TRAIL_LENGTH];
int  p3y[TRAIL_LENGTH];

int  p3QueueOldest;
int  p3QueueNewest;
int  p3CurDirection;
int  p3NewDirection;

int  p3Speed;

/*......................................................................................*/
/* player 1 temp variables.                                                             */
/*......................................................................................*/

int   p3Index;
int   p3NextNewest;
int   p3NextOldest;
int   p3CheckX;
int   p3CheckY;
int   p3HitColor;

/*--------------------------------------------------------------------------------------*/
/* initP3() - initialize player # 2.                                                    */
/*--------------------------------------------------------------------------------------*/

initP3()
{
	/*........................................................................*/
	/* initialize screen location.                                            */
	/*........................................................................*/  

	p3x[0] = p3x[1] = P3_START_X;
	p3y[0] = p3y[1] = P3_START_Y;
	
	p3CurDirection  = MOVE_UP;
    p3Speed         = SP_MEDIUM;
	
	/*........................................................................*/
	/* initialize queue pointers.                                             */
	/*........................................................................*/
	
	p3QueueOldest = 0;
	p3QueueNewest = 1;

	/*........................................................................*/
	/* initialize sprite location.                                            */
	/*........................................................................*/

	spr_set( 3 );
	spr_x( p3x[p3QueueNewest] );
	spr_y( p3y[p3QueueNewest] );
  
}
/*--------------------------------------------------------------------------------------*/
/* p3UpdateSprite() - update player 2 sprite location.                                  */
/*--------------------------------------------------------------------------------------*/

p3UpdateSprite()
{
	spr_set( 3 );
	
	/*........................................................................*/
	/* Directions.                                                            */
	/*........................................................................*/

	if( p3CurDirection == MOVE_UP    )  
	{
		spr_ctrl( FLIP_MAS, 0);
		spr_pattern( 0x0C00 + bike[2] * 128 );
		spr_x( p3x[p3QueueNewest] - 8);
		spr_y( p3y[p3QueueNewest] - 4);
	}
	if( p3CurDirection == MOVE_DOWN  )
	{
		spr_ctrl( FLIP_MAS, FLIP_Y );
		spr_pattern( 0x0C00 + bike[2] * 128 );
		spr_x( p3x[p3QueueNewest] - 8);
		spr_y( p3y[p3QueueNewest] - 4);
	}
	if( p3CurDirection == MOVE_RIGHT )
	{
		spr_ctrl( FLIP_MAS, 0 );
		spr_pattern( 0x0C00 + bike[2] * 128 + 0x40);
		spr_x( p3x[p3QueueNewest] - 4);
		spr_y( p3y[p3QueueNewest] - 8);
	}
	if( p3CurDirection == MOVE_LEFT  )
	{
		spr_ctrl( FLIP_MAS, FLIP_X );
		spr_pattern( 0x0C00 + bike[2] * 128 + 0x40 );
		spr_x( p3x[p3QueueNewest] - 4);
		spr_y( p3y[p3QueueNewest] - 8);
	}
}

/*--------------------------------------------------------------------------------------*/
/* p3CheckCollision() - check for player 2 collision.                                   */
/*--------------------------------------------------------------------------------------*/

p3CheckCollision()
{
    p3CheckX = p3x[ p3QueueNewest ] + DeltaX[ p3CurDirection ];
	p3CheckY = p3y[ p3QueueNewest ] + DeltaY[ p3CurDirection ];
	
	for( p3Index = 1; p3Index <= p3Speed; p3Index ++ )
	{
		p3CheckX = p3CheckX + DeltaX[ p3CurDirection ];
		p3CheckY = p3CheckY + DeltaY[ p3CurDirection ];
		
		if( gfx_point( p3CheckX, p3CheckY ) != 0 ) 
		{
		   return( 1 );
		}
    }
	return( 0 );
}
/*--------------------------------------------------------------------------------------*/
/* p3UpdateTrail() - update player twos trail; this updates the endpont que as well.    */
/*--------------------------------------------------------------------------------------*/

p3UpdateTrail()
{
	p3NewDirection = p3GetDirection();
	if( p3NewDirection != p3CurDirection )
	{
        /*..........................................................................*/
		/* if line array is full, erase oldest line.                                */
		/*..........................................................................*/
		
        if( p3QueueFull() )
		{
		    p3NextOldest = p3QNextOldest();
			p3EraseTrail();
		    p3QueueOldest = p3NextOldest;
		}
		
        /*..........................................................................*/
        /* add new line to line array.                                              */
        /*..........................................................................*/

		p3NextNewest = p3QNextNewest( p3QueueNewest );

		p3x[p3NextNewest] = p3x[p3QueueNewest];
		p3y[p3NextNewest] = p3y[p3QueueNewest];
		p3QueueNewest     = p3NextNewest;
		p3CurDirection    = p3NewDirection;
    }
}
/*--------------------------------------------------------------------------------------*/
/* p3DrawTrail() - draw trail for player 2.                                             */
/*--------------------------------------------------------------------------------------*/

p3DrawTrail()
{
	if( p3CurDirection == MOVE_UP    )  
	{
		gfx_line( p3x[p3QueueNewest], 
				  p3y[p3QueueNewest],
				  p3x[p3QueueNewest] + DeltaX[ p3CurDirection] * p3Speed, 
				  p3y[p3QueueNewest] + DeltaY[ p3CurDirection] * p3Speed, 10 );
				  
		gfx_line( p3x[p3QueueNewest] - 1, 
				  p3y[p3QueueNewest],
				  p3x[p3QueueNewest] - 1 + DeltaX[ p3CurDirection] * p3Speed, 
				  p3y[p3QueueNewest]     + DeltaY[ p3CurDirection] * p3Speed, 10 );
    }
	if( p3CurDirection == MOVE_DOWN    )  
	{
		gfx_line( p3x[p3QueueNewest], 
				  p3y[p3QueueNewest],
				  p3x[p3QueueNewest] + DeltaX[ p3CurDirection] * p3Speed, 
				  p3y[p3QueueNewest] + DeltaY[ p3CurDirection] * p3Speed, 10 );
				  
		gfx_line( p3x[p3QueueNewest] - 1, 
				  p3y[p3QueueNewest],
				  p3x[p3QueueNewest] - 1 + DeltaX[ p3CurDirection] * p3Speed, 
				  p3y[p3QueueNewest]     + DeltaY[ p3CurDirection] * p3Speed, 10 );
    }

	if( p3CurDirection == MOVE_LEFT    )  
	{
		gfx_line( p3x[p3QueueNewest], 
				  p3y[p3QueueNewest],
				  p3x[p3QueueNewest] + DeltaX[ p3CurDirection] * p3Speed, 
				  p3y[p3QueueNewest] + DeltaY[ p3CurDirection] * p3Speed, 10 );
				  
		gfx_line( p3x[p3QueueNewest],
				  p3y[p3QueueNewest] -1,
				  p3x[p3QueueNewest]    + DeltaX[ p3CurDirection] * p3Speed, 
				  p3y[p3QueueNewest] -1 + DeltaY[ p3CurDirection] * p3Speed, 10 );
    }
	if( p3CurDirection == MOVE_RIGHT    )  
	{
		gfx_line( p3x[p3QueueNewest], 
				  p3y[p3QueueNewest],
				  p3x[p3QueueNewest] + DeltaX[ p3CurDirection] * p3Speed, 
				  p3y[p3QueueNewest] + DeltaY[ p3CurDirection] * p3Speed, 10 );
				  
		gfx_line( p3x[p3QueueNewest], 
				  p3y[p3QueueNewest] - 1,
				  p3x[p3QueueNewest]     + DeltaX[ p3CurDirection] * p3Speed, 
				  p3y[p3QueueNewest] - 1 + DeltaY[ p3CurDirection] * p3Speed, 10 );
    }

}
/*--------------------------------------------------------------------------------------*/
/* p3EraseTrail() - erase first trail in queue.                                         */
/* note: this relys on ous not having turned yet.                                       */
/*--------------------------------------------------------------------------------------*/

p3EraseTrail()
{
    p3NextOldest = p3QNextOldest();
		
	if( p3x[p3QueueOldest] == p3x[p3NextOldest]    )
	{
		gfx_line( p3x[p3QueueOldest], p3y[p3QueueOldest],
				  p3x[p3NextOldest ], p3y[p3NextOldest ], 0 );
				  
		gfx_line( p3x[p3QueueOldest] - 1, p3y[p3QueueOldest],
				  p3x[p3NextOldest ] - 1, p3y[p3NextOldest ], 0 );
    }
	if( p3y[p3QueueOldest] == p3y[p3NextOldest]    )
	{
		gfx_line( p3x[p3QueueOldest], p3y[p3QueueOldest],
				  p3x[p3NextOldest ], p3y[p3NextOldest ], 0 );
				  
		gfx_line( p3x[p3QueueOldest], p3y[p3QueueOldest] - 1,
				  p3x[p3NextOldest ], p3y[p3NextOldest ] - 1, 0 );
    }
}
/*--------------------------------------------------------------------------------------*/
/* p3UpdateDeath() - update player 2 sprite location.                                   */
/*--------------------------------------------------------------------------------------*/

p3UpdateDeath()
{
	spr_set( 3 );
	
	/*........................................................................*/
	/* Directions.                                                            */
	/*........................................................................*/
	if(frame % 4 == 0)	
	{
		spr_pattern( ExplodeAddress );
	}
	else
	{
		
		if(frame % 3 == 0) 
		{
			spr_ctrl(FLIP_MAS, FLIP_X);
			spr_pattern(ExplodeAddress + 0x40);
		}
		else if(frame % 2 == 0)
		{
			spr_ctrl(FLIP_MAS, FLIP_Y);
			spr_pattern(ExplodeAddress + 0x40);
		}
		else
		{
			spr_ctrl(FLIP_MAS, 0);
			spr_pattern(ExplodeAddress + 0x40);
		}	
	}
	
	if( p3CurDirection == MOVE_UP    )  
	{
		spr_x( p3x[p3QueueNewest] - 8);
		spr_y( p3y[p3QueueNewest] - 4);
	}
	if( p3CurDirection == MOVE_DOWN  )
	{
		spr_x( p3x[p3QueueNewest] - 8);
		spr_y( p3y[p3QueueNewest] - 4);
	}
	if( p3CurDirection == MOVE_RIGHT )
	{
		spr_x( p3x[p3QueueNewest] - 4);
		spr_y( p3y[p3QueueNewest] - 8);
	}
	if( p3CurDirection == MOVE_LEFT  )
	{
		spr_x( p3x[p3QueueNewest] - 4);
		spr_y( p3y[p3QueueNewest] - 8);
	}
}
