/****************************************************************************************/
/* Racer5.c - functions and data for racer #5                                           */
/*--------------------------------------------------------------------------------------*/

#define  P5_START_X        170
#define  P5_START_Y        40

int  p5x[TRAIL_LENGTH];
int  p5y[TRAIL_LENGTH];

int  p5QueueOldest;
int  p5QueueNewest;
int  p5CurDirection;
int  p5NewDirection;

int  p5Speed;

/*......................................................................................*/
/* player 1 temp variables.                                                             */
/*......................................................................................*/

int   p5Index;
int   p5NextNewest;
int   p5NextOldest;
int   p5CheckX;
int   p5CheckY;
int   p5HitColor;

/*--------------------------------------------------------------------------------------*/
/* initP5() - initialize player # 5.                                                    */
/*--------------------------------------------------------------------------------------*/

initP5()
{
	/*........................................................................*/
	/* initialize screen location.                                            */
	/*........................................................................*/  

	p5x[0] = p5x[1] = P5_START_X;
	p5y[0] = p5y[1] = P5_START_Y;
	
	p5CurDirection  = MOVE_DOWN;
    p5Speed         = SP_MEDIUM;
	
	/*........................................................................*/
	/* initialize queue pointers.                                             */
	/*........................................................................*/
	
	p5QueueOldest = 0;
	p5QueueNewest = 1;

	/*........................................................................*/
	/* initialize sprite location.                                            */
	/*........................................................................*/

	spr_set( 5 );
	spr_x( p5x[p5QueueNewest] );
	spr_y( p5y[p5QueueNewest] );
  
}
/*--------------------------------------------------------------------------------------*/
/* p5UpdateSprite() - update player 2 sprite location.                                  */
/*--------------------------------------------------------------------------------------*/

p5UpdateSprite()
{
	spr_set( 5 );
	
	/*........................................................................*/
	/* Directions.                                                            */
	/*........................................................................*/

	if( p5CurDirection == MOVE_UP    )  
	{
		spr_ctrl( FLIP_MAS, 0);
		spr_pattern( 0x0C00 + bike[4] * 128 );
		spr_x( p5x[p5QueueNewest] - 8);
		spr_y( p5y[p5QueueNewest] - 4);
	}
	if( p5CurDirection == MOVE_DOWN  )
	{
		spr_ctrl( FLIP_MAS, FLIP_Y );
		spr_pattern( 0x0C00 + bike[4] * 128 );
		spr_x( p5x[p5QueueNewest] - 8);
		spr_y( p5y[p5QueueNewest] - 4);
	}
	if( p5CurDirection == MOVE_RIGHT )
	{
		spr_ctrl( FLIP_MAS, 0 );
		spr_pattern( 0x0C00 + bike[4] * 128 + 0x40);
		spr_x( p5x[p5QueueNewest] - 4);
		spr_y( p5y[p5QueueNewest] - 8);
	}
	if( p5CurDirection == MOVE_LEFT  )
	{
		spr_ctrl( FLIP_MAS, FLIP_X );
		spr_pattern( 0x0C00 + bike[4] * 128 + 0x40 );
		spr_x( p5x[p5QueueNewest] - 4);
		spr_y( p5y[p5QueueNewest] - 8);
	}
}

/*--------------------------------------------------------------------------------------*/
/* p5CheckCollision() - check for player 2 collision.                                   */
/*--------------------------------------------------------------------------------------*/

p5CheckCollision()
{
    p5CheckX = p5x[ p5QueueNewest ] + DeltaX[ p5CurDirection ];
	p5CheckY = p5y[ p5QueueNewest ] + DeltaY[ p5CurDirection ];
	
	for( p5Index = 1; p5Index <= p5Speed; p5Index ++ )
	{
		p5CheckX = p5CheckX + DeltaX[ p5CurDirection ];
		p5CheckY = p5CheckY + DeltaY[ p5CurDirection ];
		
		if( gfx_point( p5CheckX, p5CheckY ) != 0 ) 
		{
		   return( 1 );
		}
    }
	return( 0 );
}
/*--------------------------------------------------------------------------------------*/
/* p5UpdateTrail() - update player twos trail; this updates the endpont que as well.    */
/*--------------------------------------------------------------------------------------*/

p5UpdateTrail()
{
	p5NewDirection = p5GetDirection();
	if( p5NewDirection != p5CurDirection )
	{
        /*..........................................................................*/
		/* if line array is full, erase oldest line.                                */
		/*..........................................................................*/
		
        if( p5QueueFull() )
		{
		    p5NextOldest = p5QNextOldest();
			p5EraseTrail();
		    p5QueueOldest = p5NextOldest;
		}
		
        /*..........................................................................*/
        /* add new line to line array.                                              */
        /*..........................................................................*/

		p5NextNewest = p5QNextNewest( p5QueueNewest );

		p5x[p5NextNewest] = p5x[p5QueueNewest];
		p5y[p5NextNewest] = p5y[p5QueueNewest];
		p5QueueNewest     = p5NextNewest;
		p5CurDirection    = p5NewDirection;
    }
}
/*--------------------------------------------------------------------------------------*/
/* p5DrawTrail() - draw trail for player 2.                                             */
/*--------------------------------------------------------------------------------------*/

p5DrawTrail()
{
	if( p5CurDirection == MOVE_UP    )  
	{
		gfx_line( p5x[p5QueueNewest], 
				  p5y[p5QueueNewest],
				  p5x[p5QueueNewest] + DeltaX[ p5CurDirection] * p5Speed, 
				  p5y[p5QueueNewest] + DeltaY[ p5CurDirection] * p5Speed, 12 );
				  
		gfx_line( p5x[p5QueueNewest] - 1, 
				  p5y[p5QueueNewest],
				  p5x[p5QueueNewest] - 1 + DeltaX[ p5CurDirection] * p5Speed, 
				  p5y[p5QueueNewest]     + DeltaY[ p5CurDirection] * p5Speed, 12 );
    }
	if( p5CurDirection == MOVE_DOWN    )  
	{
		gfx_line( p5x[p5QueueNewest], 
				  p5y[p5QueueNewest],
				  p5x[p5QueueNewest] + DeltaX[ p5CurDirection] * p5Speed, 
				  p5y[p5QueueNewest] + DeltaY[ p5CurDirection] * p5Speed, 12 );
				  
		gfx_line( p5x[p5QueueNewest] - 1, 
				  p5y[p5QueueNewest],
				  p5x[p5QueueNewest] - 1 + DeltaX[ p5CurDirection] * p5Speed, 
				  p5y[p5QueueNewest]     + DeltaY[ p5CurDirection] * p5Speed, 12 );
    }

	if( p5CurDirection == MOVE_LEFT    )  
	{
		gfx_line( p5x[p5QueueNewest], 
				  p5y[p5QueueNewest],
				  p5x[p5QueueNewest] + DeltaX[ p5CurDirection] * p5Speed, 
				  p5y[p5QueueNewest] + DeltaY[ p5CurDirection] * p5Speed, 12 );
				  
		gfx_line( p5x[p5QueueNewest],
				  p5y[p5QueueNewest] -1,
				  p5x[p5QueueNewest]    + DeltaX[ p5CurDirection] * p5Speed, 
				  p5y[p5QueueNewest] -1 + DeltaY[ p5CurDirection] * p5Speed, 12 );
    }
	if( p5CurDirection == MOVE_RIGHT    )  
	{
		gfx_line( p5x[p5QueueNewest], 
				  p5y[p5QueueNewest],
				  p5x[p5QueueNewest] + DeltaX[ p5CurDirection] * p5Speed, 
				  p5y[p5QueueNewest] + DeltaY[ p5CurDirection] * p5Speed, 12 );
				  
		gfx_line( p5x[p5QueueNewest], 
				  p5y[p5QueueNewest] - 1,
				  p5x[p5QueueNewest]     + DeltaX[ p5CurDirection] * p5Speed, 
				  p5y[p5QueueNewest] - 1 + DeltaY[ p5CurDirection] * p5Speed, 12 );
    }

}
/*--------------------------------------------------------------------------------------*/
/* p5EraseTrail() - erase first trail in queue.                                         */
/* note: this relys on ous not having turned yet.                                       */
/*--------------------------------------------------------------------------------------*/

p5EraseTrail()
{
    p5NextOldest = p5QNextOldest();
		
	if( p5x[p5QueueOldest] == p5x[p5NextOldest]    )
	{
		gfx_line( p5x[p5QueueOldest], p5y[p5QueueOldest],
				  p5x[p5NextOldest ], p5y[p5NextOldest ], 0 );
				  
		gfx_line( p5x[p5QueueOldest] - 1, p5y[p5QueueOldest],
				  p5x[p5NextOldest ] - 1, p5y[p5NextOldest ], 0 );
    }
	if( p5y[p5QueueOldest] == p5y[p5NextOldest]    )
	{
		gfx_line( p5x[p5QueueOldest], p5y[p5QueueOldest],
				  p5x[p5NextOldest ], p5y[p5NextOldest ], 0 );
				  
		gfx_line( p5x[p5QueueOldest], p5y[p5QueueOldest] - 1,
				  p5x[p5NextOldest ], p5y[p5NextOldest ] - 1, 0 );
    }
}
/*--------------------------------------------------------------------------------------*/
/* p5UpdateDeath() - update player 2 sprite location.                                  */
/*--------------------------------------------------------------------------------------*/

p5UpdateDeath()
{
	spr_set( 5 );
	
	/*........................................................................*/
	/* Directions.                                                            */
	/*........................................................................*/

	if(frame % 4 == 0)	
	{
		spr_pattern( ExplodeAddress );
	}
	else
	{
		
		if(frame % 3 == 0) 
		{
			spr_ctrl(FLIP_MAS, FLIP_X);
			spr_pattern(ExplodeAddress + 0x40);
		}
		else if(frame % 2 == 0)
		{
			spr_ctrl(FLIP_MAS, FLIP_Y);
			spr_pattern(ExplodeAddress + 0x40);
		}
		else
		{
			spr_ctrl(FLIP_MAS, 0);
			spr_pattern(ExplodeAddress + 0x40);
		}	
	}	
	
	if( p5CurDirection == MOVE_UP    )  
	{
		spr_x( p5x[p5QueueNewest] - 8);
		spr_y( p5y[p5QueueNewest] - 4);
	}
	if( p5CurDirection == MOVE_DOWN  )
	{
		spr_x( p5x[p5QueueNewest] - 8);
		spr_y( p5y[p5QueueNewest] - 4);
	}
	if( p5CurDirection == MOVE_RIGHT )
	{
		spr_x( p5x[p5QueueNewest] - 4);
		spr_y( p5y[p5QueueNewest] - 8);
	}
	if( p5CurDirection == MOVE_LEFT  )
	{
		spr_x( p5x[p5QueueNewest] - 4);
		spr_y( p5y[p5QueueNewest] - 8);
	}
}
