/****************************************************************************************/
/* Racers.c - functions and data relating to ALL racers.                                */
/*--------------------------------------------------------------------------------------*/

#define  SP_SLOW               1               /* 1 pixel per frame      */
#define  SP_MEDIUM             2
#define  SP_FAST               3

#include "racer1.c"
#include "racer2.c"
#include "racer3.c"
#include "racer4.c"
#include "racer5.c"

initRacers()
{
	int  i;

	/*.......................................................................*/
	/* set up the racers sprites and palettes.                               */
	/*.......................................................................*/
	
	for( i = 0; i < 5; i ++ )
	{
		spr_set( i+1   );        
		spr_pal( i );     
		spr_pattern( RacerAddress * bike[i] + 128 );
		
		spr_x( BaseX + i*24  );  
		spr_y( BaseY );    
		spr_pri( 1 );
		spr_show( i+1 );
	}
}

processRacer1()
{
	isDead[0] = p1CheckCollision();
	
	if( isDead[0] == 0 )
	{		
		/*.....................................................................................*/
		/* move player 1                                   ? above and left.                   */
		/*.....................................................................................*/

		p1DrawTrail();
		
		if(p1Speed == SP_SLOW)
		{
			psgPlay(10);
		}
		else if(p1Speed == SP_MEDIUM)
		{
			psgPlay(11);
		}
		else
		{
			psgPlay(12);
		}
		
		
		p1x[p1QueueNewest] += DeltaX[ p1CurDirection] * p1Speed;
		p1y[p1QueueNewest] += DeltaY[ p1CurDirection] * p1Speed;

		/*.....................................................................................*/
		/* check for turn : update line array, if he changed direction                         */
		/*.....................................................................................*/

		p1UpdateTrail();
		p1UpdateSprite();
		
		
	}
	else
	{
		psgPlay(26);
	    p1UpdateDeath();
	    if( p1QueueOldest != p1QueueNewest )
        {
			p1NextOldest = p1QNextOldest();
			p1EraseTrail();
			p1QueueOldest = p1NextOldest;
	    }
		else
		{
		   spr_hide( 1 );
		}
	}
	
}

processRacer2()
{
	isDead[1] = p2CheckCollision();

	if( isDead[1] == 0 )
	{		
		/*.....................................................................................*/
		/* move player 1                                   ? above and left.                   */
		/*.....................................................................................*/

		p2DrawTrail();
		
		if(p2Speed == SP_SLOW)
		{
			psgPlay(13);
		}
		else if(p2Speed == SP_MEDIUM)
		{
			psgPlay(14);
		}
		else
		{
			psgPlay(15);
		}		
		
		p2x[p2QueueNewest] += DeltaX[ p2CurDirection] * p2Speed;
		p2y[p2QueueNewest] += DeltaY[ p2CurDirection] * p2Speed;

		/*.....................................................................................*/
		/* check for turn : update line array, if he changed direction                         */
		/*.....................................................................................*/

		p2UpdateTrail();
		p2UpdateSprite();
	}
	else
	{
		psgPlay(26);
	    p2UpdateDeath();
	    if( p2QueueOldest != p2QueueNewest )
        {
			p2NextOldest = p2QNextOldest();
			p2EraseTrail();
			p2QueueOldest = p2NextOldest;
	    }
		else
		{
		   spr_hide( 2 );
		}
	}
}
processRacer3()
{
	isDead[2] = p3CheckCollision();

	if( isDead[2] == 0 )
	{		
		/*.....................................................................................*/
		/* move player 3                                   ? above and left.                   */
		/*.....................................................................................*/

		p3DrawTrail();
		
		if(p3Speed == SP_SLOW)
		{
			psgPlay(16);
		}
		else if(p3Speed == SP_MEDIUM)
		{
			psgPlay(17);
		}
		else
		{
			psgPlay(18);
		}			
		
		p3x[p3QueueNewest] += DeltaX[ p3CurDirection] * p3Speed;
		p3y[p3QueueNewest] += DeltaY[ p3CurDirection] * p3Speed;

		/*.....................................................................................*/
		/* check for turn : update line array, if he changed direction                         */
		/*.....................................................................................*/

		p3UpdateTrail();
		p3UpdateSprite();
	}
	else
	{
		psgPlay(26);
	    p3UpdateDeath();
	    if( p3QueueOldest != p3QueueNewest )
        {
			p3NextOldest = p3QNextOldest();
			p3EraseTrail();
			p3QueueOldest = p3NextOldest;
	    }
		else
		{
		   spr_hide( 3 );
		}
	}
}
processRacer4()
{
	isDead[3] = p4CheckCollision();

	if( isDead[3] == 0 )
	{		
		/*.....................................................................................*/
		/* move player 3                                   ? above and left.                   */
		/*.....................................................................................*/

		p4DrawTrail();
		
		if(p4Speed == SP_SLOW)
		{
			psgPlay(19);
		}
		else if(p4Speed == SP_MEDIUM)
		{
			psgPlay(20);
		}
		else
		{
			psgPlay(21);
		}			
		
		p4x[p4QueueNewest] += DeltaX[ p4CurDirection] * p4Speed;
		p4y[p4QueueNewest] += DeltaY[ p4CurDirection] * p4Speed;

		/*.....................................................................................*/
		/* check for turn : update line array, if he changed direction                         */
		/*.....................................................................................*/

		p4UpdateTrail();
		p4UpdateSprite();
	}
	else
	{
		psgPlay(26);
	    p4UpdateDeath();
	    if( p4QueueOldest != p4QueueNewest )
        {
			p4NextOldest = p4QNextOldest();
			p4EraseTrail();
			p4QueueOldest = p4NextOldest;
	    }
		else
		{
		   spr_hide( 4 );
		}
	}
}
processRacer5()
{
	isDead[4] = p5CheckCollision();

	if( isDead[4] == 0 )
	{		
		/*.....................................................................................*/
		/* move player 3                                   ? above and left.                   */
		/*.....................................................................................*/

		p5DrawTrail();

		if(p5Speed == SP_SLOW)
		{
			psgPlay(22);
		}
		else if(p2Speed == SP_MEDIUM)
		{
			psgPlay(23);
		}
		else
		{
			psgPlay(24);
		}	
		p5x[p5QueueNewest] += DeltaX[ p5CurDirection] * p5Speed;
		p5y[p5QueueNewest] += DeltaY[ p5CurDirection] * p5Speed;

		/*.....................................................................................*/
		/* check for turn : update line array, if he changed direction                         */
		/*.....................................................................................*/

		p5UpdateTrail();
		p5UpdateSprite();
	}
	else
	{
		psgPlay(26);
	    p5UpdateDeath();
	    if( p5QueueOldest != p5QueueNewest )
        {
			p5NextOldest  = p5QNextOldest();
			p5EraseTrail();
			p5QueueOldest = p5NextOldest;
	    }
		else
		{
		   spr_hide( 5 );
		}
	}
}
