/************************************************************************************************/
/* Round.c - function to play one round (a single run) of game.                                 */
/*..............................................................................................*/

playRound()
{
  int  i;
  int  WhoWon;
  int  nAlive;
  
  /*........................................................................................*/
  /* clear screen, initialize players and draw the board.                                   */
  /*........................................................................................*/
  
  gfx_clear(0x1000 );
  gfx_init( 0x1000 );

  initP1();  initP2();  initP3();  initP4();  initP5();
  drawBorder();
  /*........................................................................................*/
  /* clear information about who is dead and who isn't.                                     */
  /*........................................................................................*/

  for( i = 0; i < 5; i ++ )
  {
	isDead[i] = 0;
  }
  allDead   = 0;

  /*........................................................................................*/
  /* count number of human players, hide non-humans.                                        */
  /*........................................................................................*/
 
  nAlive = 0; 
  for( i = 0; i < 5; i ++ )
  {
     if( flags[i] )
	 {
	   nAlive++;
	 }
	 else
	 {
	    spr_hide( i + 1 );
	 }
  }
  satb_update();
  
  /*........................................................................................*/
  /* play until only one guy left alive.                                                    */
  /*........................................................................................*/

  while( allDead < nAlive - 1 )
  {
    vsync( 0 );

	/*.....................................................................................*/
	/* update player controls.                                                             */
	/*.....................................................................................*/
	frame++;
	if(frame >= 60) frame = 0;
	ReadPads();
	allDead = 0;
	
	/*.....................................................................................*/
    /* process player 1, if he's a human.                                                  */
	/*.....................................................................................*/
	
	if( flags[0] )
	{
		/*et_color( 256, 0700 );*/
		if( isDead[0] == 0 )	processRacer1();
		else p1UpdateDeath();
		if( isDead[0] != 0 )    allDead ++;
    }
	/*.....................................................................................*/
    /* process player 2, if he's a human.                                                  */
	/*.....................................................................................*/
	
	if( flags[1] )
	{
		/*set_color( 256, 0007 );*/
		if( isDead[1] == 0 )   processRacer2();
		else p2UpdateDeath();
		if( isDead[1] != 0 )   allDead ++;
    }
	/*.....................................................................................*/
    /* process player 3, if he's a human.                                                  */
	/*.....................................................................................*/

	if( flags[2] )
	{
		/*set_color( 0, 0770 );*/
		if( isDead[2] == 0 )   processRacer3();
		else p3UpdateDeath();
		if( isDead[2] != 0 )   allDead ++;
    }
	/*.....................................................................................*/
    /* process player 4, if he's a human.                                                  */
	/*.....................................................................................*/
	
	if( flags[3] )
	{
		/*set_color( 0, 0707 );*/
		if( isDead[3] == 0 )   processRacer4();
		else p4UpdateDeath();
		if( isDead[3] != 0 )   allDead ++;
    }
	/*.....................................................................................*/
    /* process player 5, if he's a human.                                                  */
	/*.....................................................................................*/
	
	if( flags[4] )
	{
		/*set_color( 0, 0777 );*/
		if( isDead[4] == 0 )   processRacer5();
		else p5UpdateDeath();
		if( isDead[4] != 0 )   allDead ++;
    }
	
	set_color( 0, 0 );
    satb_update();
  }
  /*.................................................................................*/
  /* display winner.                                                                 */
  /*.................................................................................*/
  
  WhoWon = displayWinner();
  return( WhoWon );
}

/*.................................................................................*/
/* displayWinner()- print who won, taking care to handle ties and no one winning   */
/*.................................................................................*/

displayWinner()
{

  int   i;
  int   txtY;
  int   Winner;
  
  Winner    = -1;
  txtY      = 14;
  
  /*...........................................................................*/
  /* if they are still alive, acknowledge it.                                  */
  /*...........................................................................*/
  cls();
  for( i = 0; i < 5; i ++ )
  {
    if( flags[i] )
	{
		if( isDead[i] == 0 )
		{
		   put_string( "PLAYER ", 13, txtY );
		   put_number( i+1, 2, 19, txtY );
		   txtY++;
		   Winner = i;
		}
	}
  }
  /*...........................................................................*/
  /* depending on how many made it, print win message.                         */
  /*...........................................................................*/

  if( Winner == -1 )
  {
	   put_string( "NOBODY", 13, txtY );
	   txtY++;
  }
  put_string( "  WINS ", 13, txtY );
  
  /*...........................................................................*/
  /* wait 1 seconds.                                                           */
  /*...........................................................................*/
  
  txtY = 0;
  while( txtY < 60 )
  {
 	vsync(0);
	txtY++;
  }
  /*...........................................................................*/
  /* wait for acknowledgement from winner.                                     */
  /*...........................................................................*/
  
  if( Winner != -1 )
  {
    /*.............................................................*/
	/* but only if its a human player.                             */
	/*.............................................................*/
	
    if( flags[Winner] )
	{
      put_string( " PRESS I TO CONTINUE ", 6, 17 );
	  joystick[ Winner ] = 0;
	  while( joystick[Winner] == 0 )
	  {
		 vsync(0);
		 joystick[Winner] = joy( Winner );
	  }
	}
  }
  return( Winner );
}