/***************************************************************************/
/* ballAddDeltaX() - Add Ball Delta X to Ball Position.                    */
/*-------------------------------------------------------------------------*/
/* Copyright (c) 2011 By Michael E. Ward and Andrew 'Arkhan' Darovich		*/
/*				All Rights Reserved.               										*/
/*.........................................................................*/

ballAddDeltaX()
{
#asm
	clc
	lda		_Ball_Fdx
	adc		_Ball_Fx
	sta		_Ball_Fx
	
	lda		_Ball_Dx
	adc		_Ball_X
	sta		_Ball_X
	
	lda		_Ball_Dx+1
	adc		_Ball_X+1
	sta		_Ball_X+1
#endasm
}

/***************************************************************************/
/* ballAddDeltaY() - Add Ball Delta Y to Ball Position.                    */
/*-------------------------------------------------------------------------*/

ballAddDeltaY()
{
#asm
	clc
	lda		_Ball_Fdy
	adc		_Ball_Fy
	sta		_Ball_Fy
	
	lda		_Ball_Dy
	adc		_Ball_Y
	sta		_Ball_Y
	
	lda		_Ball_Dy+1
	adc		_Ball_Y+1
	sta		_Ball_Y+1

#endasm
}

/***************************************************************************/
/* ballFlipDeltaX() - Negate Ball Delta X.                                 */
/*-------------------------------------------------------------------------*/

ballFlipDeltaX()
{
#asm
	sec
	cla
	sbc		_Ball_Fdx
	sta		_Ball_Fdx
	
	cla
	sbc		_Ball_Dx
	sta		_Ball_Dx
	
	cla
	sbc		_Ball_Dx+1
	sta		_Ball_Dx+1
#endasm
}

/***************************************************************************/
/* ballFlipDeltaY() - Negate Ball Delta Y.                                 */
/*-------------------------------------------------------------------------*/

ballFlipDeltaY()
{
#asm
	sec
	cla
	sbc		_Ball_Fdy
	sta		_Ball_Fdy
	
	cla
	sbc		_Ball_Dy
	sta		_Ball_Dy
	
	cla
	sbc		_Ball_Dy+1
	sta		_Ball_Dy+1

#endasm
}

#include  "dxtab.asm"
#include  "speedtab.asm"

/***************************************************************************/
/* ballResetDeltaY() - reset Ball Delta Y, based on where it hit paddle.   */
/*-------------------------------------------------------------------------*/
/* this really should be a table lookup, though.                           */
/*.........................................................................*/

ballResetDeltaY()
{
#asm

	;---------------------------------------------------------------------
	; load index, make positive offset
	
	lda		_Ball_DeltaIX
	
	clc				; range is -8 to 31.
	adc		#8		; make lowest 'hit' index 0
	tax
	
	;---------------------------------------------------------------------
	; check for bad value. Abort if we have one
	
	bmi		.out
	cmp		#41		; past end of table?
	bpl		.out
	
	;---------------------------------------------------------------------
	; copy fraction 
	
	lda		dx_tab_l,x
	sta		_Ball_Fdy
	
	;---------------------------------------------------------------------
	; copy low
	
	lda		dx_tab_m,x	; most indexes are 0.			
	sta		_Ball_Dy

	;---------------------------------------------------------------------
	; clear high
	
	stz		_Ball_Dy+1
		
.out
#endasm
}