
/***************************************************************************/
/* the Y motion delta table.                                               */
/*-------------------------------------------------------------------------*/
/* Each entry is a 3 byte value, of the form (h*256) + m + n/256.          */
/* Since we have to maintain the original DY direction, all entries are    */
/* positive values. Thus we always use a high byte of 0.                   */
/* The table contains one entry for each pixel difference between the      */
/* current ball position, and the current paddle position.                 */
/* The actual value used is sin(angle)*256.                                */
/*-------------------------------------------------------------------------*/
/* the center area is 4 pixels high: I would prefer to make it 2 pixels    */
/* and expand the extreme angles at the ends by another pixel. I may do    */
/* that yet.                                                               */
/*-------------------------------------------------------------------------*/

#asm
dx_tab_l
;                               ; pixel difference / angle / region 
			.db		221			; -8               / 60    / 5
			.db		221			; -7               / 60    / 5
			.db		221			; -6               / 60    / 5
			
			.db		221			; -5               / 45    / 4
			.db		221			; -4               / 45    / 4
			.db		221			; -3               / 45    / 4
			.db		221			; -2               / 45    / 4
			        
			.db		221			; -1               / 30    / 3
			.db		221			; 0                / 30    / 3
			.db		181			; 1                / 30    / 3
			.db		181			; 2                / 30    / 3
			        
			.db		181			; 3                / 15    / 2
			.db		181			; 4                / 15    / 2
			.db		181			; 5                / 15    / 2
			.db		181			; 6                / 15    / 2
                    
			.db		181			; 7                /  5    / 1
			.db		181			; 8                /  5    / 1
			.db		181			; 9                /  5    / 1
			.db		181			; 10               /  5    / 1
			
			.db		0			; 11                /  0   / 0
			.db		0			; 12                /  0   / 0
			
			.db		181			; 13                /  5    / 1
			.db		181			; 14                /  5    / 1
			.db		181			; 15                /  5    / 1
			.db		181			; 16                /  5    / 1
			        
			.db		181			; 17                /  15   / 2
			.db		181			; 18                /  15   / 2
			.db		181			; 19                /  15   / 2
			.db		181			; 20                /  15   / 2
			        
			.db		181			; 21                /  30   / 3
			.db		181			; 22                /  30   / 3
			.db		221			; 23                /  30   / 3
			.db		221			; 24                /  30   / 3
			        
			.db		221			; 25                /  45   / 4
			.db		221			; 26                /  45   / 4
			.db		221			; 27                /  45   / 4
			.db		221			; 28                /  45   / 4
			
			.db		221			; 29                /  60   / 5
			.db		221			; 30                /  60   / 5
			.db		221			; 31                /  60   / 5
			.db		221			; 32                /  60   / 5
			
dx_tab_m
			.db		0				; -8
			.db		0				; -7
			.db		0				; -6
			.db		0				; -5
			.db		0				; -4
			.db		0				; -3
			.db		0				; -2
			.db		0				; -1
			.db		0				;  0
			.db		0				; 1
			.db		0				; 2
			.db		0				; 3
			.db		0				; 4
			.db		0				; 5
			.db		0				; 6
			.db		0				; 7
			.db		0				; 8
			.db		0				; 9
			.db		0				; 10
			.db		0				; 11
			.db		0				; 12
			.db		0				; 13
			.db		0				; 14
			.db		0				; 15
			.db		0				; 16
			.db		0				; 17
			.db		0				; 18
			.db		0				; 19
			.db		0				; 20
			.db		0				; 21
			.db		0				; 22
			.db		0				; 23
			.db		0				; 24
			.db		0				; 25
			.db		0				; 26
			.db		0				; 27
			.db		0				; 28
			.db		0				; 29
			.db		0				; 30
			.db		0				; 31
			.db		0				; 32
#endasm
