/*
   ; I'm still dropping to about 30fps with 4 shots on screen, but
   ; that may be due to other things.
   ; I will need to time the various sub-routines to see whos sucking
   ; up a lot of time....
   ; I drop to about 20fps with all 16 shots out, and all the smaller
   ; rocks moving. And I Still need to add ship-shot and ship-rock
   ; collision checks, as well as 4 more ships! A LOT of this is
   ; gonna need converted to asm if I want 60fps, or even 30fps.
   ; so... What do I need to do to time individual routines???
   ; And...Can I get the jump tables in, and see if that helps....
   ;----------------------------------------------------------------
   ; going to a square table helped some. Not enough, but some.
   ; I think.
   ;----------------------------------------------------------------
   ; moving parameters from stack to globals got me up to 30fps (min)
   ; with all 16 little rocks and all 16 shots out at once. I don't
   ; yet know how much I'm overflowing a frame by, but maybe moving
   ; some of the rest to assembler will help....
   ; And I don't think it's all in the rock collisions. I'm only getting
   ; 30fps with all the rocks gone, and 16 shots out. Hm....
   
*/

int   diffX;
int   diffY;
int   radius;

char  t;
char  s;

char  m1, m2, m3;

#include "sqrtab.asm"

/*-----------------------------------------------------------------------------------*/
/* checkRockShotCollisions() - check for collision between shots and rocks.          */
/*-----------------------------------------------------------------------------------*/

checkRockShotCollisions()
{
   #asm
   ;---------------------------------------------------------------------
   ; loop through shots.
   
   clx				; X is Shot Number
   
shot_loop
   stx	_shot_no
   
   ;---------------------------------------------------------------------
   ;  check to see if shot is active; skip it if it isn't
   
   lda		_ShotActive,x
   bne		.shotActive
   jmp		shot_loop_bottom
   
.shotActive

   ;---------------------------------------------------------------------
   ; loop through rocks. 

   cly			 	; Y is rock number
   
rock_loop
	sty		_rock_no
	
   ;----------------------------------------------------------------
   ; check rock active flag
   
   lda		_RockActive,y
   bne		.rockActive
   jmp      rock_loop_bottom
   
.rockActive

   ;----------------------------------------------------------------
   ; check rock type; if it's a type 5 (Right of 64x64), ignore it.

   lda		_RockType,y		; get type of rock
   cmp		#5
   bne		.skip3
   jmp      rock_loop_bottom
.skip3

   ;----------------------------------------------------------------
   ; both rock[Y] and shot[X] are active. decide if they hit.
   ; step 1) subtract shot location from rock location.
   ;................................................................
   ; we can probably pick up some speed if we do checks and flip
   ; the subtractions. Right now, what we have is okay....
   
   sec
   lda		_RockScreenXl, y
   sbc		_ShotScreenXl, x
   sta		_diffX
   
   lda		_RockScreenXh, y
   sbc		_ShotScreenXh, x
   sta		_diffX+1
   
   sec
   lda		_RockScreenYl, y
   sbc		_ShotScreenYl, x
   sta		_diffY
   
   lda		_RockScreenYh, y
   sbc		_ShotScreenYh, x
   sta		_diffY+1

   ;----------------------------------------------------------------
   ; step 2) convert differences to positive values

   lda	  _diffX+1
   bpl	  .skipX			; already positive, skip complement

   ;.................................................................
   ; instead of finding the complement, subtract it from 0
   
   sec
   cla
   sbc	  _diffX
   sta	  _diffX
   cla   
   sbc	  _diffX+1
   sta    _diffX+1
   
   ;.................................................................
   ; diffX is now positive. convert diffY
   
.skipX

   lda	  _diffY+1
   bpl	  .skipY
   
   sec
   cla
   sbc	  _diffY
   sta	  _diffY
   cla   
   sbc	  _diffY+1
   sta    _diffY+1
   
.skipY
   
   ;----------------------------------------------------------------
   ; step 3) calculate max radius. Thats rock radius + shot radius (2)
   
   lda		_RockType, y		; what type rock ?
   tay							; use as index for size
   lda		_rockSize,Y			; get size
   lsr      a					; radius is 1/2 diameter.
   
   clc
   adc		#2					; shot radius is 2
   sta		_radius
   stz		_radius+1

   ;----------------------------------------------------------------
   ; kick any distances > radius
   
   sec									; compare is actually subtraction
   lda		_diffX						; this -should- do 16 bit subtract
   sbc		_radius						; and leave flags set right
   lda		_diffX+1
   sbc		_radius+1

   bcc		.checkYHi					; if diffX < radius, we're okay
   jmp		rock_loop_bottom
   
.checkYHi

   sec
   lda		_diffY
   sbc		_radius
   lda		_diffY+1
   sbc		_radius+1
   
   bcc		.checkDist
   jmp		rock_loop_bottom

.checkDist

   phx
   phy
   
   ;----------------------------------------------------------------
   ; check r^2 < dx^2 + dy^2

   lda		_diffX			; index for x^2
   asl		a
   tax
   lda		_diffY			; index for y^2
   asl		a
   tay
   
   clc						; we go ahead and add them, since it has to be done
   lda		sqrtab,x
   adc		sqrtab,y
   sta		_diffX
   
   lda		sqrtab+1,x
   adc		sqrtab+1,y
   sta		_diffX+1

   ;.....................................................................
   ; diffX now holds dx^2 + dy^2.
   
   lda		_radius			; index for r^2
   asl		a
   tax 

   sec
   lda		_diffX
   sbc      _sqr,x
   lda		_diffX+1
   sbc		_sqr+1,x
   
   ply
   plx
   bcc		.Hit			; ie, (dx^2+dy^2)-r^2 < 0
                            ; or, (dx^2+dy^2) < r^2
   jmp		rock_loop_bottom

.Hit

   ;----------------------------------------------------------------
   ; if we made it this far, the shot hit the rock.
   ; split the rock, and kill off the shot
   
    stz		_ShotActive,x			; kill shot

	lda		_ShotOwner,x			; get owning ship
	phx
	tax
	dec		_ShotsFired,x			; free shot
	plx
	
    ;-----------------------------------------------------------------
	; and play sound
    ;-----------------------------------------------------------------
	
    pha							; save in case we need it
	lda		#PSGF_PLAY
	sta		<_dh
	
    lda		#_ROCK_SOUND_					; track to play
    sta     _al
    stz     _ah
	
    ;-----------------------------------------------------------------
	; and call bios.
    ;-----------------------------------------------------------------

	jsr 	psg_bios
    pla	

	;--------------------------------------------------------------------------
	;   hide the shot sprite

	phy						; Y is rock #
    phx						; save indexes. X is shot #
	
    txa						; load shot #
    clc
    adc		#_FIRST_SHOT
    tax	   					    ; sprite number goes in X. we can ignore A
	ldy		#1					; not selected sprite
    call  	_spr_hide  			; call HuC function. has to be call, to make
                                ; sure it's mapped in.
	
	;--------------------------------------------------------------------------
    ; add points for rock to players score

    plx
	phx
	
	lda		_ShotOwner,x
	sta		_playerNumber

    ldy		_rock_no
	lda		_RockType,y
	
	asl		a						; two bytes for points
	tay								; use as index
	
	lda		_RockPoints,y			; set points parameter
	sta		_pointsToAdd
	lda		_RockPoints+1,y
	sta		_pointsToAdd+1
	
	call	_addToScore
	
	;--------------------------------------------------------------------------
    ; split the rock : splitRock trashes the registers.
	
	call    _splitRock				; split the rock

    plx								; restore shot ?
	ply								; restore rock ?

	jmp		shot_loop_bottom		; exit rock loop

   ;---------------------------------------------------------------------
   ; move to next rock, via size
   
rock_loop_bottom
   lda		_RockType,y				; get type of rock
   tay								; use as index
   lda		_rockSprites,y			; get # sprites for the rock type

   clc					
   adc		_rock_no				; add to rock number
   sta		_rock_no				; save new rock number
   tay								; load new rock number

   cmp		#_MAX_ROCKS		 	    ; if rock_no is 16 or above, done
   beq		shot_loop_bottom
   jmp      rock_loop				; if not done, loop
   
   ;---------------------------------------------------------------------
   ; move to next shot
   
shot_loop_bottom
   inx
   cpx		#_MAX_SHOTS
   beq		.out
   jmp		shot_loop
.out   
   rts   
   #endasm
}
/*-----------------------------------------------------------------------------------*/
/* checkRockShipCollisions() - check for collisions between ships and rocks.         */
/*-----------------------------------------------------------------------------------*/

checkRockShipCollisions()
{
   #asm
   ;---------------------------------------------------------------------
   ; loop through ships.
   
   clx				; X is Ship Number
   
ship_loop_2
   stx	_ship_no
   
   ;---------------------------------------------------------------------
   ;  check to see if shot is active; skip it if it isn't
   
   lda		_ShipState,x
   and		#_SHIP_ALIVE
   bne		.skip1
   jmp		ship_loop_bottom_2
.skip1

   ;---------------------------------------------------------------------
   ; loop through rocks. 

   cly			 	; Y is rock number
   
rock_loop_2
	sty		_rock_no
	
   ;----------------------------------------------------------------
   ; check rock active flag
   
   lda		_RockActive,y
   bne		.skip2
   jmp      rock_loop_bottom_2
.skip2

   ;----------------------------------------------------------------
   ; check rock type; if it's a type 5 (Right of 64x64), ignore it.

   lda		_RockType,y		; get type of rock
   cmp		#5
   bne		.skip3
   jmp      rock_loop_bottom_2
.skip3

   ;----------------------------------------------------------------
   ; both rock[Y] and ship[X] are active. decide if they hit.
   ; step 1) subtract ship location from rock location.
   ;................................................................
   ; we can probably pick up some speed if we do checks and flip
   ; the subtractions. Right now, what we have is okay....
   
   sec
   lda		_RockScreenXl, y
   sbc		_ShipScreenXl, x
   sta		_diffX
   
   lda		_RockScreenXh, y
   sbc		_ShipScreenXh, x
   sta		_diffX+1
   
   sec
   lda		_RockScreenYl, y
   sbc		_ShipScreenYl, x
   sta		_diffY
   
   lda		_RockScreenYh, y
   sbc		_ShipScreenYh, x
   sta		_diffY+1

   ;----------------------------------------------------------------
   ; step 2) convert differences to positive values

   lda	  _diffX+1
   bpl	  .skipX			; already positive, skip complement

   ;.................................................................
   ; instead of finding the complement, subtract it from 0
   
   sec
   cla
   sbc	  _diffX
   sta	  _diffX
   cla   
   sbc	  _diffX+1
   sta    _diffX+1
   
.skipX

   lda	  _diffY+1
   bpl	  .skipY
   
   sec
   cla
   sbc	  _diffY
   sta	  _diffY
   cla   
   sbc	  _diffY+1
   sta    _diffY+1
   
.skipY
   
   ;----------------------------------------------------------------
   ; step 3) calculate max radius. Thats rock radius + shot radius (2)
   
   lda		_RockType, y		; what type rock ?
   tay							; use as index for size
   lda		_rockSize,Y			; get size
   lsr      a					; radius is 1/2 diameter.
   
   clc
   adc		#8					; ship radius is 8
   sta		_radius
   stz		_radius+1

   ;----------------------------------------------------------------
   ; kick any distances > radius
   
   sec									; compare is actually subtraction
   lda		_diffX						; this -should- do 16 bit subtract
   sbc		_radius						; and leave flags set right
   lda		_diffX+1
   sbc		_radius+1

   bcc		.checkYHi					; if diffX < radius, we're okay
   jmp		rock_loop_bottom_2
   
.checkYHi

   sec
   lda		_diffY
   sbc		_radius
   lda		_diffY+1
   sbc		_radius+1
   
   bcc		.checkDist
   jmp		rock_loop_bottom_2

.checkDist

   phx
   phy
   
   ;----------------------------------------------------------------
   ; check r^2 < dx^2 + dy^2

   lda		_diffX			; index for x^2
   asl		a
   tax
   lda		_diffY			; index for y^2
   asl		a
   tay
   
   clc						; we go ahead and add them, since it has to be done
   lda		_sqr,x
   adc		_sqr,y
   sta		_diffX
   
   lda		_sqr+1,x
   adc		_sqr+1,y
   sta		_diffX+1

   ;.....................................................................
   ; diffX now holds dx^2 + dy^2.
   
   lda		_radius			; index for r^2
   asl		a
   tax 

   sec
   lda		_diffX
   sbc      _sqr,x
   lda		_diffX+1
   sbc		_sqr+1,x
   
   ply
   plx
   bcc		.Hit			; ie, (dx^2+dy^2)-r^2 < 0
                            ; or, (dx^2+dy^2) < r^2
   jmp		rock_loop_bottom_2

.Hit
;   ;--------------------------DEBUG-------------   
;   phx
;   phy
;   #endasm
;   put_number( shot_no, 4, 0, 1 );
;   put_string( "Hit",      5, 1 );
;   put_number( rock_no, 4,10, 1 );
;/*   WaitForButtonB(); */
;   #asm
;   ply
;   plx
;   #endasm
;   
;   #asm

   ;----------------------------------------------------------------
   ; if we made it this far, the ship hit the rock.
   ; split the rock, and kill off the ship
   
	lda		_ShipState,x		; mark ship as DYING
    ora		#_SHIP_DYING
	sta		_ShipState,x
	
	call    _splitRock				; split the rock

    ;-----------------------------------------------------------------
	; and play sound
    ;-----------------------------------------------------------------
	
    pha							; save in case we need it
	lda		#PSGF_PLAY
	sta		<_dh
	
    lda		#_DEAD_SOUND_					; track to play
    sta     _al
    stz     _ah
	
    ;-----------------------------------------------------------------
	; and call bios.
    ;-----------------------------------------------------------------

	jsr 	psg_bios
    pla	
	
	jmp		ship_loop_bottom_2		; exit rock loop

   ;---------------------------------------------------------------------
   ; move to next rock, via size
   
rock_loop_bottom_2
   lda		_RockType,y				; get type of rock
   tay								; use as index
   lda		_rockSprites,y			; get # sprites for the rock type

   clc					
   adc		_rock_no				; add to rock number
   sta		_rock_no				; save new rock number
   tay								; load new rock number

   cmp		#_MAX_ROCKS				; if rock_no is 16 or above, done
   bcs		ship_loop_bottom_2
   jmp      rock_loop_2				; if not done, loop
   
   ;---------------------------------------------------------------------
   ; move to next ship
   
ship_loop_bottom_2
   inx
   cpx		#_MAX_SHIPS
   beq		.out
   jmp		ship_loop_2
.out   
   rts   
   #endasm
}
/*-----------------------------------------------------------------------------------*/
/* checkShotShipCollisions() - check for collisions between ships and shots.         */
/*-----------------------------------------------------------------------------------*/

checkShotShipCollisions()
{
   #asm
   ;---------------------------------------------------------------------
   ; loop through ships.
   
   clx				; X is Ship Number
   
ship_loop_3
   stx	_ship_no
   
   ;---------------------------------------------------------------------
   ;  check to see if ship is active; skip it if it isn't
   
   lda		_ShipState,x
   and		#_SHIP_ALIVE
   bne		.skip1
   jmp		ship_loop_bottom_3
.skip1

   ;---------------------------------------------------------------------
   ; loop through shots.
   
   cly				; Y is Shot Number
   
shot_loop_3
   sty	_shot_no
   
   ;---------------------------------------------------------------------
   ;  check to see if shot is active; skip it if it isn't
   ; --- also need to check if it's already dying.....
   
   lda		_ShotActive,y
   bne		.skip1
   jmp		shot_loop_bottom_3
.skip1

   ;---------------------------------------------------------------------
   ; shot[Y] and ship[X] are active. Does the shot belong to this ship ?
   
   lda		_ShotOwner,Y			; who owns this shot?
   sta		_diffX
   cpx		_diffX
   
   bne		.skip5
   jmp		shot_loop_bottom_3		; yes, ignore it   
.skip5 
  
   ;----------------------------------------------------------------
   ; both shot[Y] and ship[X] are active. decide if they hit.
   ; step 1) subtract shot location from ship location.
   ;................................................................
   ; we can probably pick up some speed if we do checks and flip
   ; the subtractions. Right now, what we have is okay....
   
   sec
   lda		_ShotScreenXl, y
   sbc		_ShipScreenXl, x
   sta		_diffX
   
   lda		_ShotScreenXh, y
   sbc		_ShipScreenXh, x
   sta		_diffX+1
   
   sec
   lda		_ShotScreenYl, y
   sbc		_ShipScreenYl, x
   sta		_diffY
   
   lda		_ShotScreenYh, y
   sbc		_ShipScreenYh, x
   sta		_diffY+1

   ;----------------------------------------------------------------
   ; step 2) convert differences to positive values

   lda	  _diffX+1
   bpl	  .skipX			; already positive, skip complement

   ;.................................................................
   ; instead of finding the complement, subtract it from 0
   
   sec
   cla
   sbc	  _diffX
   sta	  _diffX
   cla   
   sbc	  _diffX+1
   sta    _diffX+1
   
.skipX

   lda	  _diffY+1
   bpl	  .skipY
   
   sec
   cla
   sbc	  _diffY
   sta	  _diffY
   cla   
   sbc	  _diffY+1
   sta    _diffY+1
   
.skipY
   
   ;----------------------------------------------------------------
   ; step 3) calculate max radius. Thats ship radius (8) + shot radius (2)
   
   lda		#10   
   sta		_radius
   stz		_radius+1

   ;----------------------------------------------------------------
   ; kick any distances > radius
   
   sec									; compare is actually subtraction
   lda		_diffX						; this -should- do 16 bit subtract
   sbc		_radius						; and leave flags set right
   lda		_diffX+1
   sbc		_radius+1

   bcc		.checkYHi					; if diffX < radius, we're okay
   jmp		shot_loop_bottom_3
   
.checkYHi

   sec
   lda		_diffY
   sbc		_radius
   lda		_diffY+1
   sbc		_radius+1
   
   bcc		.checkDist
   jmp		shot_loop_bottom_3

   ;----------------------------------------------------------------
   ; check distance: X is ship number, Y is shot number
   
.checkDist

   phx
   phy
   
   ;----------------------------------------------------------------
   ; check r^2 < dx^2 + dy^2

   lda		_diffX			; index for x^2
   asl		a
   tax
   lda		_diffY			; index for y^2
   asl		a
   tay
   
   clc						; we go ahead and add them, since it has to be done
   lda		_sqr,x
   adc		_sqr,y
   sta		_diffX
   
   lda		_sqr+1,x
   adc		_sqr+1,y
   sta		_diffX+1

   ;.....................................................................
   ; diffX now holds dx^2 + dy^2.
   
   lda		_radius			; index for r^2
   asl		a
   tax 

   sec
   lda		_diffX
   sbc      _sqr,x
   lda		_diffX+1
   sbc		_sqr+1,x
   
   ply
   plx
   bcc		.Hit			; ie, (dx^2+dy^2)-r^2 < 0
                            ; or, (dx^2+dy^2) < r^2
   jmp		shot_loop_bottom_3

.Hit

   ;----------------------------------------------------------------
   ; if we made it this far, the shot hit the ship.
   ; kill off the ship
   ; Y should be shot, X should be ship
   
   
	lda		_ShipState,x		; mark ship as DYING
    ora		#_SHIP_DYING
	sta		_ShipState,x

   ;----------------------------------------------------------------
   ; kill off the shot

    cla
    sta		_ShotActive,y			; kill shot
	lda		_ShotOwner,y			; get owning ship
	
;	phy								; Y is shot #
;   phx								; save indexes. X is ship #

	tax
	dec		_ShotsFired,x			; free shot

	;----------------------------------------------------------------
	; award points for shooting ship.
	
	stx		_playerNumber
	
	lda		#1					; set points parameter: 100
	sta		_pointsToAdd+1
	stz		_pointsToAdd
	call	_addToScore
	
	;--------------------------------------------------------------------------
	;   hide the shot sprite
	
	lda		_shot_no
    clc
    adc		#_FIRST_SHOT
    tax	   					    ; sprite number goes in X. we can ignore A
	ldy		#1					; not selected sprite
    call  	_spr_hide  			; call HuC function. has to be call, to make
                                ; sure it's mapped in.

	;-----------------------------------------------------------------
	; and play sound
    ;-----------------------------------------------------------------
	
    pha							; save in case we need it
	lda		#PSGF_PLAY
	sta		<_dh
	
    lda		#_DEAD_SOUND_					; track to play
    sta     _al
    stz     _ah
	
    ;-----------------------------------------------------------------
	; and call bios.
    ;-----------------------------------------------------------------

	jsr 	psg_bios
    pla	
	
    ldx		_ship_no
	ldy		_shot_no
	
	jmp		ship_loop_bottom_3		; exit shot loop

   ;---------------------------------------------------------------------
   ; move to next shot.

shot_loop_bottom_3

   iny
   cpy	   #_MAX_SHOTS
   beq	   ship_loop_bottom_3
   jmp	   shot_loop_3
   
   ;---------------------------------------------------------------------
   ; move to next ship
   
ship_loop_bottom_3
   inx
   cpx		#_MAX_SHIPS
   beq		.out
   jmp		ship_loop_3
.out   
;   rts   
   #endasm
}
