/*.....................................................................................*/
/* font.c - font definitions and functions.                                            */
/*.....................................................................................*/
/* resource definitions. Where it loads in VRAM, and which palette it uses.            */
/*.....................................................................................*/

#define  FontBaseAddress 0x0800
#define  FontPaletteNo    0

/*.....................................................................................*/
/* the actual resources. Data comes from Font.pcx.                                     */
/*.....................................................................................*/

#incchr(theFont, "Font/Font.PCX" )
#incpal(FontPal, "Font/Font.PCX" ) 

/*.....................................................................................*/
/* initFont() - initialize the font.                                                   */
/*.....................................................................................*/

initFont()
{
    /*.........................................................................*/
	/* load palette and glyphs for font.                                       */
	/*.........................................................................*/

    load_palette( FontPaletteNo, FontPal, 1 );
	load_font(    theFont, 96, FontBaseAddress );

    /*.........................................................................*/
    /* tell the system about the new font.                                     */
    /*.........................................................................*/

	set_font_addr( FontBaseAddress );
	set_font_pal(  FontPaletteNo   );   /* which palette to use for fonts */
}