/***************************************************************************/
/* Rock.h - header file for rock data.                                     */
/*-------------------------------------------------------------------------*/
/* TIMING functions. Color is G B R, so rocks are  blue.                   */
/*.........................................................................*/

#define ROCK_TRACE_ON	  	set_color( 256, 0070 );	
#define ROCK_TRACE_OFF	 	set_color( 256, 0000 );

/*.........................................................................*/

#define    MAX_ROCKS          16
#define    FIRST_ROCK         32

#asm
_MAX_ROCKS	= 16
_FIRST_ROCK = 32
#endasm

#define    ROCK_8X8             1
#define    ROCK_16X16           2
#define    ROCK_32X32           3
#define    ROCK_64X64L          4
#define    ROCK_64X64R          5

const int RockPoints[ 6 ] = { 0x0000, 0x0100, 0x0050, 0x0025, 0x0010, 0x0010 };

/*.........................................................................*/
/* rocks are expected to be at specific indexes: It works this way...      */
/* an 8x8 rock can be any index.                                           */
/* a 16x16 rock will split into 2 8x8 rocks. So they can only occur every  */
/* 2 indexes. (So when the 16x16 rock N splits, it will become N and N+1)  */
/* a 32x32 rock will split into 2 16x16 rocks, so they can only occur      */
/* every 4 indexes. (Which leaves room for 2 16x16s at N and N+2, which in */
/* turn can be split into 8x8's).                                          */
/* a 64x64 rock actually is made of 2 32x64 sprites, and can only occur    */
/* every 8 indexes; it uses N and N+4 -automagically-.                     */
/*.........................................................................*/
/* so it looks like this:                                                  */
/*   0 | A = 8x8 | a = 16x16 | AA = 32x32 | aaL = 64x64 |                  */
/*   1 | B = 8x8 | ----------| ---------- | ----------- |                  */
/*   2 | C = 8x8 | b = 16x16 | ---------- | ----------- |                  */
/*   3 | D = 8x8 | --------- | ---------- | ----------- |                  */
/*   4 | E = 8x8 | c = 16x16 | BB = 32x32 | aaR = 64x64 |                  */
/* etc.                                                                    */
/*.........................................................................*/
/* Rock coordinates.                                                       */
/*.........................................................................*/

char  RockActive[   MAX_ROCKS ];

char  RockScreenXf[ MAX_ROCKS ];		/* accumulator for fractions */
char  RockScreenXl[ MAX_ROCKS ];
char  RockScreenXh[ MAX_ROCKS ];

char  RockScreenYf[ MAX_ROCKS ];
char  RockScreenYl[ MAX_ROCKS ];
char  RockScreenYh[ MAX_ROCKS ];

char  RockDeltaXf[ MAX_ROCKS ];
char  RockDeltaXl[ MAX_ROCKS ];
char  RockDeltaXh[ MAX_ROCKS ];

char  RockDeltaYf[  MAX_ROCKS ];
char  RockDeltaYl[  MAX_ROCKS ];
char  RockDeltaYh[  MAX_ROCKS ];

/*.....................................................................................*/
/* rock animation information.                                                         */
/*.....................................................................................*/

char   RockType[           MAX_ROCKS ];
char   RockHeading[        MAX_ROCKS ];
char   RockDelay[          MAX_ROCKS ];

int    RockCurrentAddress[ MAX_ROCKS ];

/*.....................................................................................*/
/* temp indexes for managing rock array.                                               */
/*.....................................................................................*/

int   rock_no;
int   rock_inc;
int   heading;