/******************************************************************************************/
/* Score.c - potential library functions for managing the score.                          */
/*........................................................................................*/

#ifndef  SCORE_BYTES
#define  SCORE_BYTES     4
#endif

const char scoreXPos[ 4 ] = { 0, 24, 24,  0 };
const char scoreYPos[ 4 ] = { 0, 27,  1, 27 };

char  ScoreCounters[ 20 ];              /* 4 bytes score for 5 ships */

int   pointsToAdd;
int   playerNumber;
int   scoreX;

/*........................................................................................*/
/* clearScore() - re-set score to all 0's                                                 */
/*........................................................................................*/
/* called From  :  initGame()        <Game/initGame.c>                                    */
/*........................................................................................*/

clearScore()
{
   int i;
   
   for( i = 0; i < 20; i ++ )
   {
      ScoreCounters[i] = 0;
   }
}
/*........................................................................................*/
/* addToScore() - add given points to score.                                              */
/*........................................................................................*/
/* score coming in should be BCD. Somethings screwing up the add, though.                 */
/*........................................................................................*/
/*........................................................................................*/

addToScore()
{

#asm
   ;------------------------------------------------------------------------
   ; Y points to players area of score array.
   ;------------------------------------------------------------------------
   
   phy						; save old
   
   lda	_playerNumber
   asl	a
   asl	a					; times 4 bytes
   tay
   
;===========================================================================   
; add given points to low bytes of score.
;---------------------------------------------------------------------------

   sed                     ; into decimal mode: passed in values should be BCD
   lda   _pointsToAdd
   clc
   adc   _ScoreCounters,y
   sta   _ScoreCounters,y
   lda   _pointsToAdd+1
   adc   _ScoreCounters+1,y
   sta   _ScoreCounters+1,y
   cla
   adc   _ScoreCounters+2,y
   sta   _ScoreCounters+2,y
   

;===========================================================================   
;  bcd adjust score : Not sure this is really needed anymore...
;  if not, we would have to expand the addition routine to handle extra bytes
;---------------------------------------------------------------------------
   
score_1:
   cld                  ; exit decimal mode
   ply					; restore old Y
#endasm
}
/*........................................................................................*/
/* printScore() - display score on screen.                                                */
/*........................................................................................*/
/* called From:   updateTopStatic()   <Screen/ScreenOps.c>                                */
/*                updateTopDynamic()  <Screen/ScreenOps.c>                                */
/*........................................................................................*/

showScore()
{
   int  i;
   
   /*
   sta _font_base+1
   */
   for( playerNumber = 0; playerNumber < 4; playerNumber++ )
   {
       if( ShipState[ playerNumber ] & SHIP_ACTIVE )
	   {
		   scoreX = scoreXPos[ playerNumber];
		   
		   /*....................................................................*/
		   /* this asm block changes the text palette on the fly, so it matches  */
		   /* the players ship. This only works because we loaded the ship       */
		   /* palettes into the background palette area as well.                 */
		   /* Note that that means we have to match shades for text in the ship  */
		   /* palette, to make things work out right.                            */
		   /*....................................................................*/
		   
		   #asm
			pha
			lda		_playerNumber
			inc		a
			asl		A
			asl		A
			asl		A
			asl		A
			sta		<__temp
			lda		_font_base+1
			and		#$0F
			ora		<__temp
			sta		_font_base+1
			pla
			#endasm
			
		   for( i = playerNumber * 4 + 3; i >= playerNumber * 4; i -- )
		   {
			  put_hex( ScoreCounters[i], 2, scoreX, scoreYPos[ playerNumber ] );
			  scoreX = scoreX + 2;
		   }   
		}
   }
}
